Page MenuHomePhabricator

A plan for developer events
Closed, ResolvedPublic

Description

We need to define our budget request for FY2016-17 developer events, as part of T124420: Technical Collaboration narratives and budget for strategic work.

In the current fiscal year our big items are the Wikimedia-Developer-Summit-2016 and the Wikimedia-Hackathon-2016, and they comprise organization logistics plus travel sponsorship. Wikimania's hackathon is not included here because its organization and budget are part of Wikimania itself.

While the Wikimedia Hackathon looks like well aligned with T124420, as of today the significantly more expensive Summit is not very consistent with the goal of Boosting developer contributions. We have several logical options:

  • Re-focus the Summit in order to have an event that contributes directly to the Technical Collaboration team goals.
  • Stop organizing the Summit (or organize it with a different budget) and use the budget for other hackathons or developer events with a focus on outreach and community contributions.
  • Re-focus the Technical Collaboration team goals.
  • Assume that the main goal of the Summit and the Technical Collaboration team are different, but still valid in both cases.

No matter what, we need a clear plan for an ask of $120k USD ($100 for logistics, $20 for travel sponsorship) + extra accommodation costs of WMF employees (very rough and conservative assumption: 60 travelers x 3 extra nights x $200 night = $36,000 ). In previous editions we had hesitations between internal discussion vs outreach.

Event Timeline

Qgil created this task.Feb 15 2016, 12:29 PM
Qgil claimed this task.
Qgil raised the priority of this task from to High.
Qgil updated the task description. (Show Details)
Qgil added subscribers: Qgil, Rfarrand, RobLa-WMF.
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptFeb 15 2016, 12:29 PM
TheDJ added a subscriber: TheDJ.Feb 15 2016, 1:05 PM

Regarding re-focusing, supposing the summit style event in San Francisco is held in San Francisco, would it make sense to convert days 2 and 3 to a hackathon and make a stronger push for San Francisco Bay Area techies to come and help hack on Wikimedia open source projects? By the way, for the purpose of quarterly planning, I've been thinking the first week or two of February would be a good time for this sort of thing, in order to make travel budget stretch for development teams looking to do user story mapping and so forth.

Regarding other events, engagement of developer user groups in different cities for hacking sessions seems sensible. Many cities have sizable developer user groups and I imagine many of them would be happy to help. The important thing is having knowledgeable people there to guide user group members through account setup, ground rules, etc.

Regarding the centralized physical WikiDev Summit 2016, I remembered two other concepts. Not necessarily better, just food for thoughts or more investigation:

  • Canonical made their Ubuntu Developer Summit online-only at some point. I don't know exact reasons (it saves money though :P ) and if there is information available which aspects have become better or worse by that switch. They have 14:00-20:00 UTC times for it IIRC.
  • Mozilla Summit 2013 had three physical locations (two in North America, one in Europe). Timezones still apply so I'm not aware of (plus cannot remember) real-time collaboration between people at different venues. Keynotes were either streamed or recorded and played later at other venues.
TheDJ added a comment.Feb 15 2016, 4:04 PM

The summit is important and we should keep organizing it. It is the "professional/constructive relations event" to balance the "amateur/exploration relations event" of a hackathon. Yin and Yang. As to how many people and how many days.. Well that's always difficult to determine I guess.
I liked that we took the extra day this year for a hackathon, since otherwise people do that DURING the event, which is just annoying. And they will hack, because people are together and that brings a sort of cross team/crowd alignment which is difficult to achieve throughout the rest of the year.

I would welcome a few smaller developer events throughout the year in various places. Basically events that would not require a ton of scholarships, that can be organized in a simpler way. HOWEVER, events like that very much need to be carried by that same local community. The question is if we can find and enable such communities well enough, and find a rhythm in organizing those. We need a bit of TEDx kind of dynamic for that ideally.

Regarding goals: I'd say primarily, that there is a difference between focus/goals and responsibilities. I would keep those very much separate at all times.

bd808 added a subscriber: bd808.Feb 15 2016, 5:04 PM

We need an annual event where we align on the long term goals of building great software in an inclusive, consensus-oriented, open manner. Right now, I fear that many folks mistakenly believe that our current software proves it can't be done. Quim, how/where do you imagine we would come together to have the depth of conversations that we had at Wikimedia-Developer-Summit-2016? Do we need to transfer this out of your team's budget? I would hate for this event to get cancelled because it doesn't achieve a respectable "lines of code" count.

(related: RobLa's mw.org page describing "consensus-based conceptual integrity")

I agree with @TheDJ. The summit seems different but complementry to hackathon type events and i would be saddened if it was refocused. Focusing solely on boosting contributions at the expense of events targetted towards keeping existing contributors strong seems unsustainable in the same way stopping all front end work to focus solely on backend would be (or stopping all mediawiki core work to focus solely on product-ish things would be ;)

s

What makes the developer summit costly? Perhaps reducing the number of scholarships or having partial scholarships (instead of covering all travel expenses) would help?

Joe added a subscriber: Joe.Feb 16 2016, 7:46 AM

I agree with everyone who said the summit seems important; to be honest I'd explore venues different from San Francisco if that's what makes the event costly.

I agree with everything @TheDJ said.

I think the summit would actually be more costly if we moved locations without reducing the size of the event. The way we run it now, the cost for all the flights of WMF staff who do not live in SF are already covered by the WMF all hands budget. If you added in flights for all of those developers to the cost of the event it would be much more.

Also, If we held the event at a separate time in another location besides the additional costs of WMF developer flights we would have to pay for three days of venue instead of two. This year we did the 3rd day of the event for almost no cost because we were able to hold it onsite at WMF. WMF is not an appropriate venue for the first two days of the event but it was great for the final unschedule, no meeting, hackathon day.

I did my best to keep the budget low. We had Pizza for a meal. We didn't do any big exciting/costly social events. Participants had to make their own way to the venue instead of hiring buses. If we keep the same venue and hold an event of a similar size we don't really have much flexibility to reduce the budget more.

A (not very well thought out) possibility would be to explore some event venues outside of the city of San Francisco (1-3 hours away by bus) but still in the Northern CA / Greater Bay Area. We could find a meeting / sleeping venue outside of the city, bus EVERYONE out there for the extent of the event. I think we could pay less for food and venue and all social events could be onsite. That would take some venue research and wifi vetting - which would be time consuming and need to be prioritized. So without having done any of that research I think we might be able to reduce total cost a little bit but loose a bit in the areas of ease of access, travel time, participant flexibility, participation of non WMF developers from SF.

WMF itself would possibly be a good location for a similar event of 50 people or less and it could be pretty cheap - the main costs being flights, accommodation, food.
There is also the possibility of reducing the size of the event and moving it to a cheaper location outside of California / USA. Places like Las Vegas for example are suppose to be very cheap to hold conferences - although the location would probably be distracting to participants.

Regardless of the specifics of the future. Based on the feedback from this event - it was valuable to the attendees. I think we should continue to do it in some form, but I also think we have a lot of room to make it better. I have a task to write up Lessons Learned which I hope to do sometime in the next month or two. So follow this task if you are interested: https://phabricator.wikimedia.org/T124259
This task will be the start of where we decide specific changes for next year based on the feedback survey of the event.

Questions I have if anyone has any thoughts:

  • Who should be at the event?
  • Do we really need 160 people?
  • What is a good size?
  • If we reduce the size who gets left out? (89.3% of participants Strongly or Very Strongly agree that they want to attend next year)
  • If the Developer Relations team and I continue to be as heavily involved we would need to make the event more community / 3rd party dev based and less WMF focused. I think that means at least 51% non WMF staff. (or what foes that mean exactly??) If DR is not running this event, who would?
  • What would we loose if we went to a smaller more focused model?
  • What are we be sacrificing to keep the event at the large size that it is (or growing it)?

Do we really need 160 people?

It'd be interesting to know what the breakdown of that number is, in terms of wmf staff vs chapter people vs established volunteers vs novice volunteers vs other external parties (e.g. the people from google).

So does this mean that the main expense for the dev summit is finding a location that can hold 160 people?

So yes, the main expense of the Dev Summit is the venue.

We have a tiny event logistics team for the event - I am the only person and I am not even able to give the event my full attention in advance because the rest of my job continues. This is actually very abnormal for events of that scale, which usually have teams of dedicated people on logistics - so any venue that we used has to have a provided and onsite staff to help with all of the set-up and day-of logistics otherwise DR would need to hire more event people which is not really a possibility at the moment.

We also need a tech friendly event, which is harder to find than you would think - especially for a group of our size. 75 - 300 person events are awkward. We don't fit in places like the SPUR but big event centers laugh at such a "small" group. We need fast reliable wifi that reaches to all corners of the venue (hard to find). We need well equipped and supported meeting rooms with working projectors, hot spots, power outlets.
If event attendees were willing to sacrifice on wifi strength and availability in all meeting rooms our options would be a bit better - but that is also not really an option for us.

The Mission Bay Center meets all of our needs, the staff is great, and everything is set up perfectly - however it requires that we use their in house catering which is very expensive. It also charges large amounts of money per day for things like each individual power strip and each individual projector connector (not to mention all of the actual equipment and furniture). We are not able to bring in anything from the outside and the cost of all of the above mentioned in premium.

The Mission Bay Center is currently the best option and it helps us put on a professional event without WMF needing to provide the large events team and facilities/catering staff on its own. I did a large amount of research on different event venues in the area and it was basically the only workable one without making major changes to the event.

I will include the break down of who attended in the Lessons Learned which is not yet complete but was linked above.

Qgil updated the task description. (Show Details)Feb 18 2016, 10:29 AM
Qgil set Security to None.
Qgil added a comment.EditedFeb 18 2016, 10:55 AM

Let's not get too stuck on the topic of optimizing costs. @Rfarrand has been championing in this area, and I'm confident to say that every single dollar invested in the Summit goes to a well justified cost.

The question is strategic: is the Summit the type of event we need? What is its main goal, and how does it fit in the WMF strategy? These are questions that any significant WMF expense should be able to answer. We have had objective problems of unclear / competing goals for this event, and also of unclear connection with the goals of the WMF Product and Technology departments. The purpose of this discussion is to solve these problems in order to make a strong case for this event.

There are two goals that imho are fairly incompatible in a single event: roadmap alignment and developer outreach. If it is clear that the Summit is about roadmap alignment, then we can relax on objectives like % of non-WMF participants, sessions for newcomers, etc. We can also agree that (with ~85% of WMF participants) the Summit is not a direct contributor to the main goals of Community Engagement / Developer Relations, and focus on its contribution to the main goals of Technology and Product.

If we go this route, then Developer Relations would still help organizing the event, because this team has the expertise to do so, but the goals, measurement of success, and general direction of the event should be defined from a Technology and Product perspective.

From this perspective, Developer Relations could still think how the Summit helps boosting developer contributions, but the answers would go more in the direction of pushing long term topics related to volunteer contributions, and not trying to organize outreach activities towards this event.

If all this sounded too abstract, :) see the example of the Linux Foundation. They organize LinuxCon as outreach events, and then Linux Collaboration Summit plus other even more specialized events for alignment. http://events.linuxfoundation.org/

There are two goals that imho are fairly incompatible in a single event: roadmap alignment and developer outreach.

I assume the Developer Summit is not about attracting developers to start contributing/working on Wikimedia code (is that more or less what "developer outreach" means here?), but pulling existing Wikimedia developers deeper into the Wikimedia developer universe (which means contributing to higher-level architecture and roadmap discussions, so we're back to the first item "roadmap alignment")?

Rfarrand added a comment.EditedFeb 18 2016, 6:48 PM

Thanks Quim / Andre. I think the direction of this conversation. :)

The Developer Summit should be an event for developers (paid or not) who are already pretty heavily involved in Wikimedia.

I do think it is important to consider this as a community event, and prioritize it as an important one, because it is probably the only time in the year where long term developers get together to have discussion. WMF paid developers meet regularly, but having a dedicated time of year where were fly in and support our high contributing community developers at the same time as our paid developers and make sure they are all involved, heard, able to speak and contribute will, in my opinion, go a long way towards volunteer retention, contribution, satisfaction, and the ability to support the unpaid highly contributing developers in a way that is open to them to set some of the expectations for.

Maybe a smaller first two days of the Summit where the percentage of volunteer developers is higher. Then we keep the third hacking day at WMF and open it up to more of the paid developers.

I was also thinking about more outreach to chapters to ask chapters that are not normally participating in this event to nominate one or two of their highest contributing volunteer developers to send to the Summit. That way those developers can begin to build networks with the paid WMF developers, and each other, and then return home with connections, ideas, and projects?

wctaiwan removed a subscriber: wctaiwan.Feb 18 2016, 6:51 PM
Qgil closed this task as Resolved.Feb 26 2016, 10:25 AM

Alright, the conclusion to this discussion at this stage is:

The Technical Collaboration team is requesting budget to organize a Wikimedia Developer Summit and a Wikimedia Hackathon, basically for the same amounts than this year. We are betting on continuity and regular evolution of both events. This ask is entering a phase of reviews now, starting with internal Community Engagement review next week, and rest of WMF internal review starting next week,. I don't whether these "details" will make it to the WMF Annual Plan presented to the FDC and the community, but in any case we welcome any feedback at any point.

Once the budget is confirmed, we will start the discussion about goals and ownership of the Summit.

I also want to note that our team is open to support focused hackathons organized by others. For instance, we would be happy to support good plans presented to the WMF with grants requests.

In our team discussions there has also been a mention about a hypothetical scenario where we would have two hackathons in a year instead of one, just a bit smaller (around 100 people each?) and placed six months apart. One would be still be promoted directly by the WMF on an annual basis as we have done until now, the second could be pushed by another organization requesting a grant for it, and going through the Grants filter. This is a very preliminary idea that we are not going to push ourselves now. I just wanted to document it somewhere.

Thank you for your participation in this task.